package com.engine.attendance.attendanceanalysis.cmd.getclockInpoint;

import com.engine.attendance.attendanceanalysis.dto.clockpoint.ClockPointDTO;
import com.engine.attendance.attendanceanalysis.dto.clockpoint.ClockPointInfo;
import com.engine.attendance.enums.ClockPointEnum;
import com.engine.common.util.DateUtil;
import com.engine.common.util.Utils;

import java.time.ZoneOffset;
import java.util.Comparator;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * 当一天只存在上班卡点和下班卡点2个卡点时，且第一笔卡为上班，第二笔卡为下班的时候
 */
public class AdjustWhenHaveTwoClockPoint implements AdjustClockPointAction{
    @Override
    public List<ClockPointDTO> execute(ClockPointInfo clockPointInfo) {
        List<ClockPointDTO> clcokInPointList = clockPointInfo.getClcokInPointList();
        List<Map<String, Object>> scheduleResult = clockPointInfo.getScheduleResult();
        String analysisDate = clockPointInfo.getAnalysisDate();

        clcokInPointList = clcokInPointList.stream().sorted(Comparator.comparing(e-> DateUtil.getTime(e.getClassTime()).toInstant(ZoneOffset.of("+8")).toEpochMilli())).collect(Collectors.toList());

        if (clcokInPointList.size() ==2 && clcokInPointList.get(0).getPointType() == ClockPointEnum.START
        && clcokInPointList.get(1).getPointType() == ClockPointEnum.END){
            if (clcokInPointList.get(0).getTimeType() == ClockPointEnum.EMPTY){
                //当上班存在漏卡时则全天漏卡
                for (Map<String, Object> map :scheduleResult){
                    if (!Utils.getkssjTime(map,analysisDate).equals(clcokInPointList.get(0).getClassTime())){
                        clcokInPointList.add(ClockPointDTO.builder().classTime(Utils.getkssjTime(map,analysisDate)).pointType(ClockPointEnum.START).timeType(ClockPointEnum.EMPTY).classSegmentType(map.get("bdlx").toString())
                                .record(false).build());
                    }
                }
            }
            if (clcokInPointList.get(1).getTimeType() == ClockPointEnum.EMPTY){
                //当上班存在漏卡时则全天漏卡
                for (Map<String, Object> map :scheduleResult){
                    if (!Utils.getjssjTime(map,analysisDate).equals(clcokInPointList.get(1).getClassTime())){
                        clcokInPointList.add(ClockPointDTO.builder().classTime(Utils.getjssjTime(map,analysisDate)).pointType(ClockPointEnum.END).timeType(ClockPointEnum.EMPTY).classSegmentType(map.get("bdlx").toString())
                                .record(false).build());
                    }
                }
            }
            if (clcokInPointList.get(1).getTimeType() != ClockPointEnum.EMPTY && clcokInPointList.get(0).getTimeType() != ClockPointEnum.EMPTY){
                //上班时间
                String toWorkTime = clcokInPointList.get(0).getClockTime().get("signdate")+" "+clcokInPointList.get(0).getClockTime().get("signtime");
                //下班时间
                String afterWorkTime = clcokInPointList.get(1).getClockTime().get("signdate")+" "+clcokInPointList.get(1).getClockTime().get("signtime");


                if (clcokInPointList.get(0).getTimeType() == ClockPointEnum.AFTER){
                    //上班迟到
                    for (Map<String, Object> map :scheduleResult){
                        String kssj = Utils.getkssjTime(map,analysisDate);
                        String jssj = Utils.getjssjTime(map,analysisDate);
                        if (kssj.equals(clcokInPointList.get(0).getClassTime())){

                        }
                    }

                }
                if (clcokInPointList.get(1).getTimeType() == ClockPointEnum.BEFORE){
                    //下班早退

                }

            }
        }
        return null;
    }
}
